﻿package
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	public class GraphicInterface extends Sprite
	{
		private var particles:Array;
		private var particleMC:Sprite;
		private var c1:Controller;
		private var c2:Controller;
		public function GraphicInterface()
		{
			addEventListener(Event.ADDED_TO_STAGE,added_handler);	
		}
		public function added_handler(e:Event):void
		{
			particleMC = new Sprite();
			particles = new Array();
			addChild(particleMC);
			c1= new Controller(20);
			c1.x=25;
			c1.y=25;
			addChild(c1);
			c2= new Controller(20);
			c2.x=70;
			c2.y=25;
			addChild(c2);
			addEventListener(Event.ENTER_FRAME,onEnterFrame);
		}
		private function onEnterFrame(e:Event):void
		{
			createParticle();
			particleMC.graphics.clear();
			for(var i:int=particles.length-1;i>=0;i--) {
				particles[i].x += particles[i].dx;
				particles[i].y += particles[i].dy;
				var nbr:uint =  255 << 16 | Math.round(Math.abs(180-c2.controller_value())*255/360) << 8 | Math.round(Math.abs(180-c2.controller_value())*255/360);
				particleMC.graphics.beginFill(nbr,1);
				particleMC.graphics.drawCircle(particles[i].x,particles[i].y,(c1.controller_value()/10+1));
				particleMC.graphics.endFill();
				if (particles[i].life-- <= 0) {
					particles[i].dx = 0;
				    particles[i].dy = 0;
					particleMC.removeChild(particles[i]);
					particles.splice(i,1);
				}
			}
		}
		//ADAPTATION D'UNE FONCTION DE CEM DU 26_08_09
		private function createParticle():void 
		 {
			var p:MovieClip = new MovieClip();
			p.x = stage.stageWidth/2+(1-Math.random()*2);
			p.y = stage.stageHeight/2+(1-Math.random()*2);
			p.life = 100;
			p.dx = Math.random()*9-3;
			if (p.y >= stage.stageHeight/2){
			p.dy = Math.random()*4;
				}else if (p.y <=stage.stageHeight/2){
			p.dy = Math.random()*2-4;
					}
			particleMC.addChild(p);
			particles.push(p);
		}
	}
}
import flash.display.Sprite;
import flash.events.MouseEvent;
import flash.events.EventDispatcher;
import flash.events.Event;
class Controller extends Sprite{
	private var line:Sprite = new Sprite();
	public static var dispatcher:EventDispatcher;
	public function Controller(size:Number){
		dispatcher = new EventDispatcher();
		graphics.beginFill(0xff0000,.5);
		graphics.lineStyle(1,0xff0000,1);
		graphics.drawCircle(0,0,size);
		graphics.endFill();
		line.graphics.beginFill(0xff0000,1);
		line.graphics.drawRect(0,0,size,1);
		line.graphics.endFill();
		addChild(line);
		addEventListener(MouseEvent.MOUSE_DOWN,down_handler);
	}
	private function down_handler(e:MouseEvent):void
	{
		addEventListener(MouseEvent.MOUSE_MOVE,move_handler);
		stage.addEventListener(MouseEvent.MOUSE_UP,up_handler);
	}
	private function move_handler(e:MouseEvent):void
	{
		var angle:Number = Math.atan(Math.round(e.localY)/Math.round(e.localX))*180/Math.PI;
		if(e.localX<0){
			angle+=180;
		}
		e.currentTarget.line.rotation=angle-15;
	}
	private function up_handler(e:MouseEvent):void
	{
		removeEventListener(MouseEvent.MOUSE_MOVE,move_handler);
	}
	public function controller_value():Number
	{
		return line.rotation;
	}
}